#include <iostream>

#include <boost/numeric/ublas/io.hpp>
#include "orthonormalize.hpp"
#include "matrix_vector_print.hpp"

typedef boost::numeric::ublas::matrix<double> Matrix;
using boost::numeric::ublas::trans;
using myfitter::ublasutils::orthonormalize;

int main()
{
    Matrix U(3,2);
    U(0,0) =  0.3; U(0,1) =  1.2;
    U(1,0) = -2.0; U(1,1) =  0.0;
    U(2,0) = -0.1; U(2,1) = -0.6;

    if(orthonormalize(U, 1.e-10) != 2) return 1;

    if(std::abs(U(0,0) - (+0.148159)) > 1.e-5) return 1;
    if(std::abs(U(1,0) - (-0.98773)) > 1.e-5) return 1;
    if(std::abs(U(2,0) - (-0.0493865)) > 1.e-5) return 1;

    if(std::abs(U(0,1) - (0.882127)) > 1.e-5) return 1;
    if(std::abs(U(1,1) - (0.154565)) > 1.e-5) return 1;
    if(std::abs(U(2,1) - (-0.444928)) > 1.e-5) return 1;

    U.resize(3,3);
    U(0,2) =  1.3;
    U(1,2) = -0.5;
    U(2,2) = -0.1;

    if(orthonormalize(U, 1.e-10, 2) != 3) return 1;

    if(std::abs(U(0,0) - (+0.148159)) > 1.e-5) return 1;
    if(std::abs(U(1,0) - (-0.98773)) > 1.e-5) return 1;
    if(std::abs(U(2,0) - (-0.0493865)) > 1.e-5) return 1;

    if(std::abs(U(0,1) - (0.882127)) > 1.e-5) return 1;
    if(std::abs(U(1,1) - (0.154565)) > 1.e-5) return 1;
    if(std::abs(U(2,1) - (-0.444928)) > 1.e-5) return 1;

    if(std::abs(U(0,2) - (0.447102)) > 1.e-5) return 1;
    if(std::abs(U(1,2) - (0.0223551)) > 1.e-5) return 1;
    if(std::abs(U(2,2) - (0.894204)) > 1.e-5) return 1;

    U(0,2) = -0.3;
    U(1,2) =  2.0;
    U(2,2) =  0.1;

    if(orthonormalize(U, 1.e-10, 2) != 2) return 1;

    if(std::abs(U(0,0) - (+0.148159)) > 1.e-5) return 1;
    if(std::abs(U(1,0) - (-0.98773)) > 1.e-5) return 1;
    if(std::abs(U(2,0) - (-0.0493865)) > 1.e-5) return 1;

    if(std::abs(U(0,1) - (0.882127)) > 1.e-5) return 1;
    if(std::abs(U(1,1) - (0.154565)) > 1.e-5) return 1;
    if(std::abs(U(2,1) - (-0.444928)) > 1.e-5) return 1;

    return 0;
}
